diff --git a/drivers/gpu/drm/drm_auth.c b/drivers/gpu/drm/drm_auth.c
index cf92a9ae8034..c37032bccd0f 100644
--- a/drivers/gpu/drm/drm_auth.c
+++ b/drivers/gpu/drm/drm_auth.c
@@ -141,7 +141,7 @@ struct drm_master *drm_master_create(struct drm_device *dev)
 	kref_init(&master->refcount);
 	drm_master_legacy_init(master);
 	idr_init_base(&master->magic_map, 1);
-	master->dev = dev;
+	master->drm = dev;
 
 	/* initialize the tree of output resource lessees */
 	INIT_LIST_HEAD(&master->lessees);
@@ -423,7 +423,7 @@ EXPORT_SYMBOL(drm_file_get_master);
 static void drm_master_destroy(struct kref *kref)
 {
 	struct drm_master *master = container_of(kref, struct drm_master, refcount);
-	struct drm_device *dev = master->dev;
+	struct drm_device *dev = master->drm;
 
 	if (drm_core_check_feature(dev, DRIVER_MODESET))
 		drm_lease_destroy(master);
diff --git a/drivers/gpu/drm/drm_lease.c b/drivers/gpu/drm/drm_lease.c
index 150fe1555068..02d240897871 100644
--- a/drivers/gpu/drm/drm_lease.c
+++ b/drivers/gpu/drm/drm_lease.c
@@ -81,13 +81,13 @@ struct drm_master *drm_lease_owner(struct drm_master *master)
 static struct drm_master*
 _drm_find_lessee(struct drm_master *master, int lessee_id)
 {
-	lockdep_assert_held(&master->dev->mode_config.idr_mutex);
+	lockdep_assert_held(&master->drm->mode_config.idr_mutex);
 	return idr_find(&drm_lease_owner(master)->lessee_idr, lessee_id);
 }
 
 static int _drm_lease_held_master(struct drm_master *master, int id)
 {
-	lockdep_assert_held(&master->dev->mode_config.idr_mutex);
+	lockdep_assert_held(&master->drm->mode_config.idr_mutex);
 	if (master->lessor)
 		return idr_find(&master->leases, id) != NULL;
 	return true;
@@ -98,7 +98,7 @@ static bool _drm_has_leased(struct drm_master *master, int id)
 {
 	struct drm_master *lessee;
 
-	lockdep_assert_held(&master->dev->mode_config.idr_mutex);
+	lockdep_assert_held(&master->drm->mode_config.idr_mutex);
 	drm_for_each_lessee(lessee, master)
 		if (_drm_lease_held_master(lessee, id))
 			return true;
@@ -138,9 +138,9 @@ bool drm_lease_held(struct drm_file *file_priv, int id)
 		ret = true;
 		goto out;
 	}
-	mutex_lock(&master->dev->mode_config.idr_mutex);
+	mutex_lock(&master->drm->mode_config.idr_mutex);
 	ret = _drm_lease_held_master(master, id);
-	mutex_unlock(&master->dev->mode_config.idr_mutex);
+	mutex_unlock(&master->drm->mode_config.idr_mutex);
 
 out:
 	drm_master_put(&master);
@@ -169,10 +169,10 @@ uint32_t drm_lease_filter_crtcs(struct drm_file *file_priv, uint32_t crtcs_in)
 		crtcs_out = crtcs_in;
 		goto out;
 	}
-	dev = master->dev;
+	dev = master->drm;
 
 	count_in = count_out = 0;
-	mutex_lock(&master->dev->mode_config.idr_mutex);
+	mutex_lock(&master->drm->mode_config.idr_mutex);
 	list_for_each_entry(crtc, &dev->mode_config.crtc_list, head) {
 		if (_drm_lease_held_master(master, crtc->base.id)) {
 			uint32_t mask_in = 1ul << count_in;
@@ -186,7 +186,7 @@ uint32_t drm_lease_filter_crtcs(struct drm_file *file_priv, uint32_t crtcs_in)
 		}
 		count_in++;
 	}
-	mutex_unlock(&master->dev->mode_config.idr_mutex);
+	mutex_unlock(&master->drm->mode_config.idr_mutex);
 
 out:
 	drm_master_put(&master);
@@ -206,7 +206,7 @@ uint32_t drm_lease_filter_crtcs(struct drm_file *file_priv, uint32_t crtcs_in)
  */
 static struct drm_master *drm_lease_create(struct drm_master *lessor, struct idr *leases)
 {
-	struct drm_device *dev = lessor->dev;
+	struct drm_device *dev = lessor->drm;
 	int error;
 	struct drm_master *lessee;
 	int object;
@@ -215,7 +215,7 @@ static struct drm_master *drm_lease_create(struct drm_master *lessor, struct idr
 
 	drm_dbg_lease(dev, "lessor %d\n", lessor->lessee_id);
 
-	lessee = drm_master_create(lessor->dev);
+	lessee = drm_master_create(lessor->drm);
 	if (!lessee) {
 		drm_dbg_lease(dev, "drm_master_create failed\n");
 		return ERR_PTR(-ENOMEM);
@@ -265,7 +265,7 @@ static struct drm_master *drm_lease_create(struct drm_master *lessor, struct idr
 
 void drm_lease_destroy(struct drm_master *master)
 {
-	struct drm_device *dev = master->dev;
+	struct drm_device *dev = master->drm;
 
 	mutex_lock(&dev->mode_config.idr_mutex);
 
@@ -303,14 +303,14 @@ static void _drm_lease_revoke(struct drm_master *top)
 	void *entry;
 	struct drm_master *master = top;
 
-	lockdep_assert_held(&top->dev->mode_config.idr_mutex);
+	lockdep_assert_held(&top->drm->mode_config.idr_mutex);
 
 	/*
 	 * Walk the tree starting at 'top' emptying all leases. Because
 	 * the tree is fully connected, we can do this without recursing
 	 */
 	for (;;) {
-		drm_dbg_lease(master->dev, "revoke leases for %p %d\n",
+		drm_dbg_lease(master->drm, "revoke leases for %p %d\n",
 			      master, master->lessee_id);
 
 		/* Evacuate the lease */
@@ -338,9 +338,9 @@ static void _drm_lease_revoke(struct drm_master *top)
 
 void drm_lease_revoke(struct drm_master *top)
 {
-	mutex_lock(&top->dev->mode_config.idr_mutex);
+	mutex_lock(&top->drm->mode_config.idr_mutex);
 	_drm_lease_revoke(top);
-	mutex_unlock(&top->dev->mode_config.idr_mutex);
+	mutex_unlock(&top->drm->mode_config.idr_mutex);
 }
 
 static int validate_lease(struct drm_device *dev,
@@ -661,7 +661,7 @@ int drm_mode_get_lease_ioctl(struct drm_device *dev,
 
 	if (lessee->lessor == NULL)
 		/* owner can use all objects */
-		object_idr = &lessee->dev->mode_config.object_idr;
+		object_idr = &lessee->drm->mode_config.object_idr;
 	else
 		/* lessee can only use allowed object */
 		object_idr = &lessee->leases;
diff --git a/include/drm/drm_auth.h b/include/drm/drm_auth.h
index ba248ca8866f..cae829079594 100644
--- a/include/drm/drm_auth.h
+++ b/include/drm/drm_auth.h
@@ -56,7 +56,7 @@ struct drm_lock_data {
  * struct drm_master - drm master structure
  *
  * @refcount: Refcount for this master object.
- * @dev: Link back to the DRM device
+ * @drm: Link back to the DRM device
  * @driver_priv: Pointer to driver-private information.
  *
  * Note that master structures are only relevant for the legacy/primary device
@@ -64,7 +64,7 @@ struct drm_lock_data {
  */
 struct drm_master {
 	struct kref refcount;
-	struct drm_device *dev;
+	struct drm_device *drm;
 	/**
 	 * @unique: Unique identifier: e.g. busid. Protected by
 	 * &drm_device.master_mutex.